package com.example.demo.users.model;

import java.util.Date;
import java.util.List;
import java.util.Objects;

import com.example.demo.core.model.BaseEntity;

public class UserEntity extends BaseEntity {
    private String email;
    private String password;
    private Date expirationDate;
    private List<Long> watchLater;

    public UserEntity() {
        super();
    }

    public UserEntity(Long id, String email, String password, Date expirationDate, List<Long> watchLater) {
        super(id);

        this.email = email;
        this.password = password;
        this.expirationDate = expirationDate;
        this.watchLater = watchLater;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public Date getExpirationDate() {
        return expirationDate;
    }

    public void setExpirationDate(Date expirationDate) {
        this.expirationDate = expirationDate;
    }

    public List<Long> getWatchLater() {
        return watchLater;
    }

    public void setWatchLater(List<Long> watchLater) {
        this.watchLater = watchLater;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, email, password, expirationDate, watchLater);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final UserEntity other = (UserEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getEmail(), email)
                && Objects.equals(other.getPassword(), password)
                && Objects.equals(other.getExpirationDate(), expirationDate)
                && Objects.equals(other.getWatchLater(), watchLater);
    }
}
